; ----------------------------------------------------------------------------
; -      TITULO  : Prints a real number on the screen                        -
; -----                                                                  -----
; -      AUTOR   : Alfonso Vctor Caballero Hurtado                          -
; -----                                                                  -----
; -      VERSION : 1.0                                                       -
; -----                                                                  -----
; -      (c) 2012. Abre los Ojos al Ensamblador                              -
; -      http://www.abreojosensamblador.net/                                 -
; -      You can use it but, credit ;), don't be a lamer                     -
; -      Compile with: jwasm -bin -Fo RealCJ01.com RealCJ01.asm              -
; ----------------------------------------------------------------------------

; 1.005
; 0 01111111 00000001010001111010111b = 3F 80 A3 D7h

; 0.0005
; 0 01110100 00000110001001001101111b = 3A 03 12 6Fh
; 2^(116-127) * 1.00000110001001001101111

; 1 10000111 00110001101000000000000b = C3 98 D0 00h
; -1 * 2^(135-127) * 1.00110001101 = -100110001.101 = -305.625

cbFinChar    EQU   "$"
cbNFloats    EQU   6

.model tiny
.386

PrintFloat    MACRO Direccion
  ; Propsito: Imprime el nmero en punto flotante
  ; entrada  : Direccin a imprimir
  ; salida   : ninguna
  ; Destruye : AX, DX
  mov    ah, 9
  mov    dx, Direccion
  int    21h
ENDM

.data
  vdNumero        dd    0.0005
                  dd    1.0015
                  dd  100.0275
                  dd  230.0175
                  dd  -35.0178
                  dd  305.625
    vdAcumDec     dd       0
    rbNumASCII    db       20 dup(' '), 13, 10, cbFinChar
    
.data
    vdSumaFinal   db       8 dup(?)
    vmBufDivision db       8 dup(?)
    vdLonMantisa  dd       1 dup(?)
    vdLonDecimal  dd       1 dup(?)
    rwEntera      dw       1 dup(?)
    rdDecimal     dw       1 dup(?)
    rwExpon       dw       1 dup(?)
    rbSigno       db       1 dup(?)

.code
    ORG 100h
    Entrada:              
    
    mov         ecx, cbNFloats
    mov         esi, offset vdNumero
    @Principal:
      call        FTOA
      PrintFloat  di
      add         esi, 4
    loop        @Principal
    
    ; Salimos al DOS
    MOV   AX, 4c00h                       ; Servicio 4Ch, mensaje 0
    INT   21h                             ; volvemos AL DOS

    FTOA PROC
      ; Propsito: Convierte float number en ASCII
      ; Entrada  : esi: nmero en coma flotante
      ; Salida   : di: direccin donde empezar a imprimir
      ; Destruye : Ninguna
      push   ebx
      push   ecx
      push   edx
      push   esi
      mov    eax, dword ptr [ESI]

      ; Recogemos el signo (1 bit: extremo izquierda)
      mov    byte ptr [rbSigno], 0  ; Suponemos sin signo
      shl    eax, 1
      jnc    @Sgte1
        mov    byte ptr [rbSigno], 1
      @Sgte1:
      
      ; Recuperamos el exponente (8 bits siguientes)
      mov    ebx, eax
      shr    ebx, 23+1
      sub    ebx, 127
      mov    word ptr [rwExpon], bx
      
      xor    cx, cx       ; Suponemos exponente positivo
      or     bx, bx
      jns    @ExpPositivo
        mov    cx, bx
        neg    cx
        mov    word ptr [rwExpon], 0
      @ExpPositivo:
      
      ; Recuperamos la mantisa
      shl    eax, 7      ; Eliminamos el exponente
      or     eax, 10000000000000000000000000000000b  ; Ponemos el 1.
      shr    eax, 9      ; Lo ponemos su sitio, ya sin exponente
      call   CheckExpNeg
      mov    ecx, 0
      @Sin_Exp:          ; Eliminamos los ceros a la derecha
        inc    ecx
        mov    ebx, eax
        shr    eax, 1
      jnc    @Sin_Exp
      mov    eax, ebx
      mov    dword ptr [vdLonMantisa], 23
      sub    dword ptr [vdLonMantisa], ecx
      
      ; Recogemos la parte entera
      mov    ebx, eax                 ; eax ya tiene el 1. y no tiene ceros a la derecha
      mov    cx, word ptr [vdLonMantisa]
      sub    cx, word ptr [rwExpon]
      and    ecx, 0FFFFh              ; Eliminamos la parte de arriba, por si acaso
      mov    dword ptr [vdLonDecimal], ecx
      shr    ebx, cl                  ; Eliminamos decimales, slo queda parte entera
      mov    word ptr [rwEntera], bx      ; Parte entera
      
      ; Recogemos la parte decimal
      mov    ebx, eax                 ; eax ya tiene el 1. y no tiene ceros a la derecha
      mov    cx, 32   ; 16
      sub    cx, word ptr [vdLonDecimal]
      shl    ebx, cl                  ; Eliminamos la parte entera
      shr    ebx, cl                  ; Ponemos parte decimal contra borde derecho
      
      ; ** Aqu ya hemos desmenuzado el nmero real, 
      ; ** ahora hay que convertirlo a ascii
      ; Parte decimal
      call   InitSum
      mov    ecx, dword ptr [vdLonDecimal] ; Contador de posiciones
      @B_Decimal:
        shr    ebx, 1
        jnc    @B_Sgte1
          call   Divide               ; Resultado en vmBufDivision
          call   Suma                 ; Resultado en vdSumaFinal
        @B_Sgte1:
        dec    ecx
      jnz    @B_Decimal
      call   Sum2ASCII                ; Convierte la suma en ASCII
      call   CopiaSumaMatFinal        ; Copiamos la suma en la matriz final
      
      ; Separador
      mov    byte ptr [di], '.'
      dec    di
      
      ; Parte entera
      mov    ax, [rwEntera]
      call   Bin2ASCII
      
      ; Signo
      cmp    [rbSigno], 1
      jnz    @Fin
        mov    byte ptr [di], '-'
      @Fin:
      pop    esi
      pop    edx
      pop    ecx
      pop    ebx
      ret
    FTOA ENDP
    
    CheckExpNeg PROC
      ; Propsito: Chequeamos si el exponente fuera negativo para acomodar mantisa
      ; Entrada  : eax: Nmero, cx: Exponente (0 si positivo, otro caso negativo)
      ;            eax ya tiene el 1 a la izquierda y sin exponente
      ; Salida   : eax
      ; Destruye : eax
      or     cx, cx
      jz     @cen_Fin
        shr    eax, cl
      @cen_Fin:
      ret
    CheckExpNeg ENDP
    
    BaseDecimal PROC
      ; Propsito: devuelve la base para los decimales
      ; Entrada  : eax
      ; Salida   : edx: la base
      ; Destruye : Ninguna
      push   eax
      push   ebx
      push   esi
      mov    ebx, 10
      @b_bucle:
        mul    ebx
        dec    esi
      jnz    @b_bucle
      mov    edx, eax
      pop    esi
      pop    ebx
      pop    eax
      ret
    BaseDecimal ENDP
    
    Bin2ASCII PROC
      ; Propsito: convierte binario a ascii y lo va metiendo en di
      ; Entrada  : eax: num a convertir, di: donde empieza a meter en el bfer
      ; Salida   : di donde ha terminado de meter en el bfer
      ; Destruye : eax, edi
      push   ebx
      push   edx
      mov    ebx, 10
      @Bucle1:
        cmp    eax, 0
        jz     @Salir
        xor    edx, edx
        div    ebx
        or     dl, 30h
        mov    byte ptr [di], dl
        dec    di
      jmp    @Bucle1
      @Salir:
      pop    edx
      pop    ebx
      ret
    Bin2ASCII ENDP
    
    Sum2ASCII PROC
      ; Propsito: Inicializa con ceros el bfer de la suma (8 bytes)
      ; Entrada  : Ninguna
      ; Salida   : Ninguna
      ; Destruye : eax
      or      dword ptr [vdSumaFinal], 30303030h
      or      dword ptr [vdSumaFinal+4], 30303030h
      ret
    Sum2ASCII ENDP
    
    CopiaSumaMatFinal PROC
      ; Propsito: Copia el bfer de la suma en rbNumASCII
      ; Entrada  : Ninguna
      ; Salida   : edi
      ; Destruye : esi, edi
      pushf
      mov    esi, offset vdSumaFinal + 7
      mov    edi, offset rbNumASCII + 19
      mov    ecx, 7
      std                             ; Decrementamos
      rep    movsb
      popf
      ret
    CopiaSumaMatFinal ENDP
    
    InitSum PROC
      ; Propsito: Inicializa con ceros el bfer de la suma (8 bytes)
      ; Entrada  : Ninguna
      ; Salida   : Ninguna
      ; Destruye : eax
      pushf
      push    ecx 
      push    edi
      mov     eax, 0
      mov     ecx, 2
      mov     edi, offset vdSumaFinal
      cld
      rep     stosd
      pop     edi 
      pop     ecx
      popf
      ret
    InitSum ENDP
    
    Suma PROC
      ; Propsito: Suma en bytes vmBufDivision con vdSumaFinal y lo deja aqu
      ; Entrada  : Ninguna
      ; Salida   : vdSumaFinal
      ; Destruye : eax
      push    ebx 
      push    ecx 
      push    edx 
      push    esi 
      push    edi
      mov     esi, offset vmBufDivision+7
      mov     edi, offset vdSumaFinal+7
      mov     ecx, 8
      mov     dl, 0
      @Bucle:
        mov     al, byte ptr [esi]
        mov     ah, byte ptr [edi]
        add     al, ah
        add     al, dl
        mov     dl, 0
        cmp     al, 10
        jb      @Next
          mov     dl, 1
          sub     al, 10
        @Next:
        mov     byte ptr [edi], al
        dec     edi
        dec     esi
      loop    @Bucle
      pop     edi 
      pop     esi 
      pop     edx 
      pop     ecx 
      pop     ebx
      ret
    Suma ENDP
    
    Divide PROC
      ; Propsito: Divide 10000000 por 2^cl y lo trocea en bytes
      ; Entrada  : ecx: exponente de 2
      ; Salida   : vmBufDivision
      ; Destruye : eax
      pushf
      push  ebx 
      push  ecx 
      push  edx 
      push  edi
      ; Limpiamos el bfer
      push  ecx
      mov   edi, offset vmBufDivision
      mov   eax, 0
      mov   ecx, 8/4
      cld
      rep   stosd
      pop   ecx
      ;
      mov   eax, 10000000     ; Esto es lo que dividiremos
      shr   eax, cl           ; Hademos la divisin por 2^cl
      ; Ahora troceamos la divisin en bytes
      mov   edi, offset vmBufDivision+7 ; Direccin donde empezamos a escribir
      mov   ebx, 10           ; Establecemos el divisor
      @d_Bucle:
        cmp   eax, 0          ; Hemos terminado?
        jz    @d_Fin
        xor   edx, edx        ; Limpiamos de nuevo la parte superior
        div   ebx             ; Divisimos -> cociente en edx
        mov   byte ptr [edi], dl  ; Guardamos el byte
        dec   edi             ; Actualizamos puntero
      jmp   @d_Bucle
      @d_Fin:
      pop   edi 
      pop   edx 
      pop   ecx 
      pop   ebx
      popf
      ret
    Divide ENDP
END Entrada

; Salida por pantalla:
; >realcj01
;  .0004998
;  1.0014996
;  100.0274962
;  230.0174863
; -35.0177992
;  305.6250000
